%define _prefix /usr/local/%{rname}/%{version}
%define modulefile_path /usr/local/share/Modules/modulefiles/%{rname}
%define pmodulefile_path /usr/local/share/Modules/modulefiles/python/2.7/%{rname}

Version:	0.6.0
%define nversion %(echo %{version} | tr -d . )
Name:		libgpuarray%{nversion}
%define rname libgpuarray
Release:	1%{?dist}.1
Summary:	Library to manipulate tensors on the GPU

Group:		Scientific/Libraries
License:	Other
URL:		http://deeplearning.net/software/libgpuarray/
# https://github.com/Theano/libgpuarray/archive/v0.6.0.tar.gz
Source0:	libgpuarray-%{version}.tar.gz

BuildRequires:	cmake3

%description
Common GPU ndarray(n dimensions array) that can be reused by all projects that
is as future proof as possible, while keeping it easy to use for simple
need/quick test.

%package devel
Summary: Development files for %{name}
Requires: %{name} = %{version}

%description devel
Development files for libgpuarray.

%package pygpu27
Summary: Pygpu for python 2.7
BuildRequires: python27-devel Cython27 numpy27
Requires: %{name} = %{version}
Requires: python27-mako python27-six

%description pygpu27
pygpu files for python 2.7

%prep
%setup -q -n %{rname}-%{version}

%build
module load cmake
mkdir Build
cd Build
cmake3 .. -DCMAKE_INSTALL_PREFIX=%{buildroot}%{_prefix} -DCMAKE_BUILD_TYPE=Release
make
cd ..
module load python
python setup.py build_ext -L lib  -I src

%install
cd Build
make install
%if %{_lib} != "lib"
mv %{buildroot}%{_prefix}/lib %{buildroot}%{_libdir}
%endif
cd ..
module load python
#python setup.py build_ext -L %{buildroot}%{_libdir}  -I %{buildroot}%{_includedir}
python setup.py install --prefix %{_prefix} --root %{buildroot}

mkdir -p %{buildroot}%{modulefile_path}
cat > $RPM_BUILD_ROOT%{modulefile_path}/%{version} <<ENDFILE
#%Module

# NOTE: This is an automatically-generated file!

proc ModulesHelp { } {
   puts stderr "This module adds %{rname} %{version} to various paths"
}

module-whatis   "Sets up %{rname} %{version}"
prepend-path    LD_LIBRARY_PATH "%{_libdir}"
prepend-path    LIBRARY_PATH "%{_libdir}"
prepend-path    CPATH "%{_includedir}"
prepend-path    FPATH "%{_includedir}"
prepend-path    INCLUDE "%{_includedir}"
ENDFILE
mkdir -p %{buildroot}%{pmodulefile_path}
cat > $RPM_BUILD_ROOT%{pmodulefile_path}/%{version} <<ENDPFILE
#%Module

# NOTE: This is an automatically-generated file!

proc ModulesHelp { } {
   puts stderr "This module adds pygpu %{version} to python 2.7"
}

module-whatis   "Sets up pygpu %{version} for python 2.7"
module load %{rname}/%{version}
prepend-path    PYTHONPATH "%{_libdir}/python2.7/site-packages"
ENDPFILE

%check
cd Build
make test


%files
%license LICENSE
%doc README* INSTALL doc
%dir %{_prefix}
%dir /usr/local/libgpuarray
%{_libdir}/libgpu*so.*
%dir %{modulefile_path}
%{modulefile_path}/%{version}

%files devel
%{_includedir}
%{_libdir}/libgpu*so
%{_libdir}/libgpu*.a

%files pygpu27
%{_libdir}/python2.7
%dir %{pmodulefile_path}
%{pmodulefile_path}/%{version}

%changelog

